﻿var attempts = 0; // パスワードの試行回数をカウントする変数を定義する
const  fillFolder = new Folder(Folder.userData+'/passAuthN');   //アプリケーションデータが格納されるフォルダ 
const jsonFile = new File(Folder.userData+'/passAuthN/password.json');  //mac/Users/ユーザー名/Library/Application Support/passAuthN/password.json

//入力された文字を16進数に変換　ここから
function stringToHex(input) {
    var result = "";
    for (var i=0; i<input.length; i++) {
        var hex = input.charCodeAt(i).toString(16);//入力された文字を十六進数に変換
        result += ("000"+hex).slice(-4);    //末尾から4文字を取り出す
    }
    return result;
};
//入力された文字を16進数に変換　ここまで

try{
    // マスターパスワード　ここから
    if (!jsonFile.exists) {//jsonFileが存在しない場合
        //１２桁より大きい場合は処理を繰り返す　ここから
        do {
            var input = prompt("マスターパスワードを12桁以内で設定してください：");
        } while(input.length > 12);
        //１２桁より大きい場合は処理を繰り返す　ここから
        
        // JSONデータとしてマスターパスワードを書き出す　ここから
        if(! fillFolder.exists){     //fillFolder存在しない場合
				 fillFolder.create();   //フォルダ作成
			}
        jsonFile.open('w'); // 書き込みモードでファイルを開く
        jsonFile.write('{' + '"password":"' + stringToHex(input) + '"' +'}'); // パスワードをJSON形式で書き込む
        jsonFile.close(); // ファイルを閉じる
        // JSONデータとしてマスターパスワードを書き出す　ここまで
    };//if
    // マスターパスワード　ここまで

    //パスワードの確認　ここから
    while (attempts < 3) { // パスワードの試行回数が3回未満である限り、ループを続ける
        var answer = prompt("パスワードを入力してください："); // パスワードを要求する
        if (answer === null) { // キャンセルボタンが押された場合
            alert("パスワード入力がキャンセルされました。プログラムを終了します。");
            break;  //ループの終了
        } else {
            // JSONファイルからパスワードを読み込む ここから
            jsonFile.open('r'); // 読み取りモードでファイルを開く
            const storedPassword =  eval('('+jsonFile.readln()+')').password;//eval()関数はJSON文字列をJavaScriptオブジェクトに変換し、そのpasswordプロパティを取得されます。
            jsonFile.close(); // ファイルを閉じる
            // JSONファイルからパスワードを読み込む ここまで
            
            // パスワードがマッチするか　 ここから
            if (stringToHex(answer) === storedPassword) { // ユーザーが入力したパスワードが正しい場合
                alert("パスワードが正確です。スクリプトを実行します。");    // パスワードが正しい場合、スクリプトの残りの部分を実行する
            // パスワードがマッチするか　 ここまで
            
                // --------ここに実行したいスクリプトを書く----------
                alert ('サンプルスクリプト');

                break;  //ループの終了
            } else { 
                attempts++; // パスワードの試行回数を1増やす
                if (attempts < 3) { // まだ試行回数が3回未満であれば、エラーメッセージを表示する
                    alert("パスワードが間違っています。再度入力してください。");
                } else { // 試行回数が3回に達したら、エラーメッセージを表示してループから抜け出す
                    alert("パスワードを3回間違えました。プログラムを終了します。");
                }   //else
            }   //else
        }   //else
    }//while
    //パスワードの確認　ここまで
} catch (e) {
    alert("エラーが発生しました: " + e.message);  
}
/*
 .fsName：ファイルシステムに適した形式でパス名を返す
.exists：プロパティはファイルやフォルダの存在を確認する
 break：JavaScriptの制御フローステートメントの一つで、forループ、whileループ、do...whileループ、またはswitchステートメントから抜け出すために使用   
 e.message：eは、tryブロック内で発生したエラーオブジェクトを参照します。したがって、e.messageは発生したエラーの詳細なメッセージを取得します。
    
    
    
    
    */